SystemOrganization addCategory: #LandSlide!

Object subclass: #ClassDocumentation
	instanceVariableNames: 'name superClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!ClassDocumentation class methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:46'!
name: aString superClassName: anotherString
	^ ((self new) name: aString) superClassName: anotherString! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 15:17'!
name
	^ name! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 15:17'!
name: aString
	name := aString! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 17:00'!
printOn: aStream
	aStream nextPutAll: 'a ClassDocumentation(Name: '.
	aStream nextPutAll: name.
	aStream nextPutAll: ', Superclass: '.
	aStream nextPutAll: superClassName.
	aStream nextPutAll: ')'! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 15:17'!
superClassName
	^ superClassName! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 15:17'!
superClassName: aString
	superClassName := aString! !

Object subclass: #DocumentationHolder
	instanceVariableNames: 'classes methods decls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!DocumentationHolder class methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
withClasses: classes andMethods: methods
	^ (self new classes: classes) methods: methods! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
classes: theClasses
	classes := theClasses! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 14:39'!
decls
	^ decls! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 17:09'!
decls: theDecls
	decls := theDecls! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
methods: theMethods
	methods := theMethods! !

Object subclass: #LandSlideParser
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:56'!
gatherClasses: declarations
	| nodes doits classes |
	nodes := declarations 
		select: [ :decl | decl isKindOf: DoItDeclaration ]
		thenCollect: [ :decl | parser parse: (decl contents readStream) class: UndefinedObject noPattern: true context: nil notifying: nil ifFail: [  ] ].
	doits := nodes 
		select: [ :node | node selector == #DoIt ]
		thenCollect: [ :node | ((node block) statements at: 1) expr ].
	classes := doits
		select: [ :expr | expr isKindOf: MessageNode ]
		thenCollect: [ :expr | ClassDocumentation name: (((expr arguments at: 1) key) asString) superClassName: (expr receiver name) ].
	^ classes! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:20'!
gatherMethods: declarations
	^ declarations 
			select: [ :decl | decl isKindOf: MethodDeclaration ]
			thenCollect: [ :decl | parser parse: (decl contents) class: UndefinedObject  ].! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:21'!
initialize
	parser := Parser new! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:22'!
parseString: aString 
	| cffp declarations methods classes |
	"Parses a given file written in ChunkFileFormat, returning an object
	which represents the materials necessary for generating documentation"
	cffp := ChunkFileFormatParser for: (ReadStream on: aString).
	declarations := cffp parseDeclarations.
	methods := self gatherMethods: declarations.
	classes := self gatherClasses: declarations.
	^ (DocumentationHolder withClasses: classes andMethods: methods) decls: declarations.! !

Object subclass: #MonticelloUnpacker
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!MonticelloUnpacker class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:44'!
fromUrl: url
	"Passing a string url to a monticello project online this will download that 
	file and get the contents of the snapshot.st file and also will cleanup after 
	itself with all temporary files"
	| dir znurl filename unpacker stringContents |
	dir := FileSystem disk workingDirectory .
	ZnClient new
		url: url;
		downloadTo:dir . 
	znurl := ZnUrl fromString: url .
	filename := znurl lastPathSegment .
	unpacker := (MonticelloUnpacker new)
		filename: (dir / filename) .
	stringContents := unpacker extractStringFromFile .
	unpacker cleanupFile .
	^stringContents! !

!MonticelloUnpacker class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:43'!
getNewFileContents
	"This will open a filepicker where the user can select a .mcz file and our unpacker
	will take that file and get the contents of the snapshot.st file and also will cleanup after 
	itself with all temporary files"
	| file unpacker |
	file := StandardWindow new fileOpen: '' .
	unpacker := (MonticelloUnpacker new)  
		filename: file .
	^ unpacker extractStringFromFile ! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:33'!
cleanupFile
	self filename deleteAll! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:42'!
extractStringFromFile
	"This will actually take the filename used for this unpacker and extract it 
	and return the contents of snapshot.st"
	| fulldir dir zip fileStream fileContents|
	fulldir := self filename .
	zip := ZipArchive new readFrom: (fulldir fullName) .
	dir := FileSystem disk workingDirectory / 'temp'.
	dir createDirectory .
	zip extractAllTo:  dir .
	fileStream := (dir / 'snapshot' / 'source.st') readStream .
	fileContents := fileStream contents .
	dir deleteAll .
	^fileContents! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:20'!
filename
	"comment stating purpose of message"
	^ filename! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:20'!
filename: aFileName
	"comment stating purpose of message"
	filename := aFileName! !

TestCase subclass: #LandSlideTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!
